From 7a596ee3554cb5ff018deed07e9a9f484d799842 Mon Sep 17 00:00:00 2001
From: Daniel Gustafsson <daniel@yesql.se>
Date: Tue, 30 Jan 2018 16:25:08 +0100
Subject: [PATCH] Ensure all <img> tags are closed

The <img .. /> tag is required to be to closed in XHTML, as opposed
to HTML where <img ..> is valid. Properly close all currently open
img tags and also add alt="" attributes where missing.
---
 templates/account/login.html                   | 2 +-
 templates/pages/about/press/presskit10/cn.html | 4 ++--
 templates/pages/about/press/presskit10/de.html | 4 ++--
 templates/pages/about/press/presskit10/en.html | 4 ++--
 templates/pages/about/press/presskit10/es.html | 4 ++--
 templates/pages/about/press/presskit10/fr.html | 4 ++--
 templates/pages/about/press/presskit10/hi.html | 4 ++--
 templates/pages/about/press/presskit10/id.html | 4 ++--
 templates/pages/about/press/presskit10/il.html | 4 ++--
 templates/pages/about/press/presskit10/it.html | 4 ++--
 templates/pages/about/press/presskit10/kr.html | 4 ++--
 templates/pages/about/press/presskit10/my.html | 4 ++--
 templates/pages/about/press/presskit10/pt.html | 4 ++--
 templates/pages/about/press/presskit10/ru.html | 4 ++--
 templates/pages/about/press/presskit10/th.html | 4 ++--
 templates/pages/about/press/presskit10/vi.html | 4 ++--
 16 files changed, 31 insertions(+), 31 deletions(-)

diff --git a/templates/account/login.html b/templates/account/login.html
index 80f92fa..9e251a8 100644
--- a/templates/account/login.html
+++ b/templates/account/login.html
@@ -48,7 +48,7 @@ password, you can use the <a href="/account/reset/">password reset</a> form.
 {%if oauth_providers%}
 <h2>Third party sign in</h2>
 {%for p,d in oauth_providers%}
-<p><a href="/account/login/{{p}}/?next={{next}}"><img src="/media/img/misc/btn_login_{{p}}.png" alt="Sign in with {{p|capfirst}}"></a></p>
+<p><a href="/account/login/{{p}}/?next={{next}}"><img src="/media/img/misc/btn_login_{{p}}.png" alt="Sign in with {{p|capfirst}}" /></a></p>
 {%endfor%}
 {%endif%}
 
diff --git a/templates/pages/about/press/presskit10/cn.html b/templates/pages/about/press/presskit10/cn.html
index 0b88ebf..67f9b04 100644
--- a/templates/pages/about/press/presskit10/cn.html
+++ b/templates/pages/about/press/presskit10/cn.html
@@ -37,7 +37,7 @@
  &nbsp; <a href="#companies">企业支持</a><br />
 </p>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <a name="original_release"></a><h2>新版本发布说明</h2>
 
@@ -158,7 +158,7 @@ Daojing Zhou<br />
 
 <a name="graphics"><h2>相关图片和标识文件</h2></a>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <ul>
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">PostgreSQL 大象标识图片，PNG格式</a></li>
diff --git a/templates/pages/about/press/presskit10/de.html b/templates/pages/about/press/presskit10/de.html
index 0681141..9fe1922 100644
--- a/templates/pages/about/press/presskit10/de.html
+++ b/templates/pages/about/press/presskit10/de.html
@@ -38,7 +38,7 @@
  &nbsp; <a href="#companies">Professioneller Support</a><br />
 </p>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <a name="original_release"></a><h2>Originaler Text der Ver&ouml;ffentlichung</h2>
 
@@ -130,7 +130,7 @@ Telefon: +49 33056 406869</p>
 
 <a name="graphics"><h2>Bilder und Logos</h2></a>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <ul>
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">PostgreSQL Elephant Logo, PNG Format</a></li>
diff --git a/templates/pages/about/press/presskit10/en.html b/templates/pages/about/press/presskit10/en.html
index 5c18cde..25c9dff 100644
--- a/templates/pages/about/press/presskit10/en.html
+++ b/templates/pages/about/press/presskit10/en.html
@@ -38,7 +38,7 @@
  &nbsp; <a href="#companies">Corporate Support</a><br />
 </p>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <a name="original_release"></a><h2>Original Press Release</h2>
 
@@ -218,7 +218,7 @@ Arul Shaji Arulappan and Richard Sayad
 
 <a name="graphics"><h2>Images and Logos</h2></a>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <ul>
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">PostgreSQL Elephant Logo, PNG format</a></li>
diff --git a/templates/pages/about/press/presskit10/es.html b/templates/pages/about/press/presskit10/es.html
index a1c95af..a6349e4 100644
--- a/templates/pages/about/press/presskit10/es.html
+++ b/templates/pages/about/press/presskit10/es.html
@@ -38,7 +38,7 @@
  &nbsp; <a href="#companies">Apoyo corporativo</a><br />
 </p>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <a name="original_release"></a><h2>Comunicado de prensa original</h2>
 
@@ -227,7 +227,7 @@ Ernesto Lozano<br />
 
 <a name="graphics"><h2>Imágenes y logotipos</h2></a>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <ul>
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">Logotipo elefante PostgreSQL, formato PNG</a></li>
diff --git a/templates/pages/about/press/presskit10/fr.html b/templates/pages/about/press/presskit10/fr.html
index 42c9aae..afeadb3 100644
--- a/templates/pages/about/press/presskit10/fr.html
+++ b/templates/pages/about/press/presskit10/fr.html
@@ -37,7 +37,7 @@
  &nbsp; <a href="#companies">Support professionnel</a><br />
 </p>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <a name="original_release"></a><h2>Texte original</h2>
 
@@ -143,7 +143,7 @@ Stéphane Schildknecht<br />
 
 <a name="graphics"><h2>Images et logos</h2></a>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <ul>
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">Logo de l'éléphant PostgreSQL, format PNG</a></li>
diff --git a/templates/pages/about/press/presskit10/hi.html b/templates/pages/about/press/presskit10/hi.html
index 7e7bc51..c2286dd 100644
--- a/templates/pages/about/press/presskit10/hi.html
+++ b/templates/pages/about/press/presskit10/hi.html
@@ -38,7 +38,7 @@
  &nbsp; <a href="#companies">कॉर्पोरेट सहायता</a><br />
 </p>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <a name="original_release"></a><h2>मूल प्रेस विज्ञप्ति</h2>
 
@@ -138,7 +138,7 @@ Gaurav Chugani<br />
 
 <a name="graphics"><h2>छवियाँ और प्रतीक चिन्ह </h2></a>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <ul>
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">PostgreSQL Elephant Logo, PNG format</a></li>
diff --git a/templates/pages/about/press/presskit10/id.html b/templates/pages/about/press/presskit10/id.html
index 23ef7b4..3d53b71 100644
--- a/templates/pages/about/press/presskit10/id.html
+++ b/templates/pages/about/press/presskit10/id.html
@@ -38,7 +38,7 @@
  &nbsp; <a href="#companies">Dukungan Korporasi</a><br />
 </p>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <a name="original_release"></a><h2>Press Release Asli</h2>
 
@@ -133,7 +133,7 @@ Telepon: +1 (347) 674-7759</p>
 
 <a name="graphics"><h2>Gambar dan Logo</h2></a>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <ul>
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">PostgreSQL Elephant Logo, PNG format</a></li>
diff --git a/templates/pages/about/press/presskit10/il.html b/templates/pages/about/press/presskit10/il.html
index 5b64fb5..1dcb601 100644
--- a/templates/pages/about/press/presskit10/il.html
+++ b/templates/pages/about/press/presskit10/il.html
@@ -38,7 +38,7 @@
 &nbsp; <a href="#companies">תמיכה תאגידית</a><br />
 </p>
 <div dir="rtl">
- <img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+ <img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 </div>
 
 <a dir="rtl" name="original_release"></a>
@@ -128,7 +128,7 @@ Michael Goldberg<br />
 <a name="graphics"><h2 dir="rtl">תמונות וסמלים</h2></a>
 
 <div dir="rtl">
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 </div>
 <ul dir="rtl">
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">PostgreSQL סמל הפיל, בפורמט PNG</a></li>
diff --git a/templates/pages/about/press/presskit10/it.html b/templates/pages/about/press/presskit10/it.html
index 442eb5e..8e735da 100644
--- a/templates/pages/about/press/presskit10/it.html
+++ b/templates/pages/about/press/presskit10/it.html
@@ -37,7 +37,7 @@
  &nbsp; <a href="#companies">Supporto alle aziende</a><br />
 </p>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <a name="original_release"></a><h2>Comunicato stampa originale</h2>
 
@@ -126,7 +126,7 @@ Mobile: +39 338 1566217</p>
 
 <a name="graphics"><h2>Immagini e logo</h2></a>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <ul>
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">Logo elefante di PostgreSQL, formato PNG</a></li>
diff --git a/templates/pages/about/press/presskit10/kr.html b/templates/pages/about/press/presskit10/kr.html
index fe79a81..9337dc0 100644
--- a/templates/pages/about/press/presskit10/kr.html
+++ b/templates/pages/about/press/presskit10/kr.html
@@ -38,7 +38,7 @@
  &nbsp; <a href="#companies">Corporate Support</a><br />
 </p>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <a name="original_release"></a><h2>PostgreSQL 10 출시</h2>
 
@@ -142,7 +142,7 @@ Ioseph Kim<br />
 
 <a name="graphics"><h2>Images and Logos</h2></a>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <ul>
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">PostgreSQL Elephant Logo, PNG format</a></li>
diff --git a/templates/pages/about/press/presskit10/my.html b/templates/pages/about/press/presskit10/my.html
index 3386edc..1df2227 100644
--- a/templates/pages/about/press/presskit10/my.html
+++ b/templates/pages/about/press/presskit10/my.html
@@ -38,7 +38,7 @@
  &nbsp; <a href="#companies">လုပ္ငန္းဆိုင္ရာေထာက္ပံ့အားေပးမႈ</a><br />
 </p>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <a name="original_release"></a><h2>မူရင္းထုတ္ျပန္ခ်က</h2>
 
@@ -183,7 +183,7 @@ Suu Myat Khin<br />
 
 <a name="graphics"><h2> ပံုႏွင့့္အမွတ္အသားမ်ား </h2></a>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <ul>
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">PostgreSQL Elephant Logo, PNG format</a></li>
diff --git a/templates/pages/about/press/presskit10/pt.html b/templates/pages/about/press/presskit10/pt.html
index 791e9c4..35b350f 100644
--- a/templates/pages/about/press/presskit10/pt.html
+++ b/templates/pages/about/press/presskit10/pt.html
@@ -37,7 +37,7 @@
  &nbsp; <a href="#companies">Suporte Corporativo</a><br />
 </p>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <a name="original_release"></a><h2>Texto Original das Notas de Lançamento</h2>
 
@@ -131,7 +131,7 @@ Euler Taveira de Oliveira <br />
 
 <a name="graphics"><h2>Imagens e Logotipos</h2></a>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <ul>
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">Logotipo do Elefante do PostgreSQL, formato PNG</a></li>
diff --git a/templates/pages/about/press/presskit10/ru.html b/templates/pages/about/press/presskit10/ru.html
index 4a0cb25..ad9e08c 100644
--- a/templates/pages/about/press/presskit10/ru.html
+++ b/templates/pages/about/press/presskit10/ru.html
@@ -37,7 +37,7 @@
  &nbsp; <a href="#companies">Корпоративная поддержка</a><br />
 </p>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <a name="original_release"></a><h2>Официальный пресс-релиз</h2>
 
@@ -193,7 +193,7 @@
 
 <a name="graphics"><h2>Графика и логотипы</h2></a>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <ul>
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">Логотип слона PostgreSQL в формате PNG</a></li>
diff --git a/templates/pages/about/press/presskit10/th.html b/templates/pages/about/press/presskit10/th.html
index 2fd0c8f..edbdcb6 100644
--- a/templates/pages/about/press/presskit10/th.html
+++ b/templates/pages/about/press/presskit10/th.html
@@ -38,7 +38,7 @@
  &nbsp; <a href="#companies">ผู้ให้การสนับสนุน</a><br />
 </p>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <a name="original_release"></a><h2>ข่าวประชาสัมพันธ์ต้นฉบับ</h2>
 
@@ -191,7 +191,7 @@ Lilly Rangsikriangkrai <br />
 
 <a name="graphics"></a><h2>ภาพและโลโก้</h2></a>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <ul>
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">PostgreSQL Elephant Logo, PNG format</a></li>
diff --git a/templates/pages/about/press/presskit10/vi.html b/templates/pages/about/press/presskit10/vi.html
index 2dbe714..36d7f01 100644
--- a/templates/pages/about/press/presskit10/vi.html
+++ b/templates/pages/about/press/presskit10/vi.html
@@ -38,7 +38,7 @@
  &nbsp; <a href="#companies">Hỗ trợ Công ty</a><br />
 </p>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" />
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <a name="original_release"></a><h2>Thông cáo báo chí gốc</h2>
 
@@ -141,7 +141,7 @@ Bui Hung <br />
 
 <a name="graphics"><h2>Hình ảnh và logo</h2></a>
 
-<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" >
+<img src="https://www.postgresql.org/media/img/about/press/elephant64.png" alt="PostgreSQL Logo" />
 
 <ul>
 <li><a href="https://www.postgresql.org/media/img/about/press/elephant.png">PostgreSQL Elephant Logo, PNG format</a></li>
-- 
2.14.1.145.gb3622a4ee