diff --git a/docs/en_US/images/preferences_sql_auto_completion.png b/docs/en_US/images/preferences_sql_auto_completion.png
index 9c46a3c737d5d04785861ced8a0842366de8108c..6b2f07e04d55ffda3c29662f553ae5488cb98ae4 100644
GIT binary patch
diff --git a/docs/en_US/images/preferences_sql_csv_output.png b/docs/en_US/images/preferences_sql_csv_output.png
index 1d13c2cd8acc6f5017a35b777f168105c5eebfbc..48dee9c62a87640af5085cefad9dbd400912c867 100644
GIT binary patch
diff --git a/docs/en_US/images/preferences_sql_display.png b/docs/en_US/images/preferences_sql_display.png
index 8c16e8bd561c774057effbebbc59b4c3709174d3..b0e86599e4e5a523618ff418990d5f31b2f3a046 100644
GIT binary patch
diff --git a/docs/en_US/images/preferences_sql_explain.png b/docs/en_US/images/preferences_sql_explain.png
index 90c35659c177d23b9adf97139373693094c302ed..bdccab8d6ba25beeb969a46572598173cc8f5ae4 100644
GIT binary patch
diff --git a/docs/en_US/images/preferences_sql_explain_options.png b/docs/en_US/images/preferences_sql_explain_options.png
deleted file mode 100644
index dac642712e262f20c2a8d3f261700abe26f50765..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/docs/en_US/images/preferences_sql_keyboard_shortcuts.png b/docs/en_US/images/preferences_sql_keyboard_shortcuts.png
index 35c62c93316c70fe52f7e8df63ea9e3427d62afa..f66b84ce267deb154c3721c5ad26662cefcedfe4 100644
GIT binary patch
diff --git a/docs/en_US/images/preferences_sql_options.png b/docs/en_US/images/preferences_sql_options.png
index c8bd898cb4627c50847f8e0381310a6c2b815003..e98974a596bc3b2e707d363331b6495979eb2d21 100644
GIT binary patch
diff --git a/docs/en_US/images/preferences_sql_result_grid.png b/docs/en_US/images/preferences_sql_result_grid.png
deleted file mode 100644
index 7940432f93ba2f3b5615c7991db922964f213b12..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/docs/en_US/images/preferences_sql_results_grid.png b/docs/en_US/images/preferences_sql_results_grid.png
index 785f8c2034c82df59960eae5b084b830cc306264..5a994d71b3a3cb4dbc5fe7fd0a3ff8c469cf2a37 100644
GIT binary patch
diff --git a/docs/en_US/preferences.rst b/docs/en_US/preferences.rst
index ee45fa48..e47866f0 100644
--- a/docs/en_US/preferences.rst
+++ b/docs/en_US/preferences.rst
@@ -127,9 +127,9 @@ Use the fields on the *Help* panel to specify the location of help files.
 
 Please note: the default help paths include the *VERSION* placeholder; the $VERSION$ placeholder will be replaced by the current database version.
 
-**The SQL Editor Node**
+**The Query Tool Node**
 
-Expand the *SQL Editor* node to access panels that allow you to specify your preferences for the SQL Editor tool.
+Expand the *Query Tool* node to access panels that allow you to specify your preferences for the Query Editor tool.
 
 .. image:: images/preferences_sql_auto_completion.png
     :alt: Preferences dialog sqleditor auto completion option
@@ -150,13 +150,13 @@ Use the fields on the *CSV Output* panel to control the CSV output.
 .. image:: images/preferences_sql_display.png
     :alt: Preferences dialog sqleditor display options
 
-Use the fields on the *Display* panel to specify your preferences for the SQL Editor display.
+Use the fields on the *Display* panel to specify your preferences for the Query Tool display.
 
-* When the *Connection status* switch is set to *True*, each new instance of the SQL Editor will display connection and transaction status.
+* When the *Connection status* switch is set to *True*, each new instance of the Query Tool will display connection and transaction status.
 
 * Use the *Connection status refresh rate* field to specify the number of seconds between connection/transaction status updates.
 
-* When the *Open in new browser tab* switch is set to *True*, each new instance of the SQL Editor will open in a new browser tab.
+* When the *Open in new browser tab* switch is set to *True*, each new instance of the Query Tool will open in a new browser tab.
 
 * Use the *Query info notifier timeout* field to control the behaviour of the notifier that is displayed when query execution completes. A value of *-1* will disable the notifier, and a value of 0 will display it until clicked. If a positive value above zero is specified, the notifier will be displayed for the specified number of seconds. The default is *5*.
 
@@ -207,7 +207,7 @@ Use the fields on the *Results grid* panel to specify your formatting preference
 * Use the *Result copy quote character* drop-down listbox to select the quote character for copied data.
 * Use the *Result copy quoting* drop-down listbox to select which type of fields require quoting; select *All*, *None*, or *Strings*.
 
-Use the fields on the *Keyboard shortcuts* panel to configure shortcuts for the sql editor window navigation:
+Use the fields on the *Keyboard shortcuts* panel to configure shortcuts for the query tool window navigation:
 
 .. image:: images/preferences_sql_keyboard_shortcuts.png
     :alt: Preferences dialog sql keyboard shortcuts section